<template>
  <q-card :square="isDesktopPlatform">
    <q-card-section
      v-if="loading"
      class="text-center"
    >
      <q-spinner-dots
        size="md"
        color="primary"
      />
    </q-card-section>

    <q-card-section v-else-if="broadcast">
      <BroadcastDetails
        :id="broadcast.id"
        :title="broadcast.title"
        :body="broadcast.body"
        :sent-by="broadcast.sentBy"
        :sent-at="broadcast.sentAt"
        :read-status="broadcast.readStatus"
      />
    </q-card-section>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import BroadcastDetails from 'src/pages/messaging/components/BroadcastDetails'
import queryBroadcastByPk from '../graphql/queryBroadcastByPk.gql'

export default {
  name: 'BroadcastCard',
  mixins: [
    PlatformMixin
  ],
  components: {
    BroadcastDetails
  },
  props: {
    broadcastId: {
      type: Number,
      required: true
    }
  },
  emits: ['message-ready'],
  apollo: {
    broadcast: {
      query: queryBroadcastByPk,
      notifyOnNetworkStatusChange: true,
      update: data => data.broadcast_by_pk,
      result () {
        this.$emit('message-ready', this.broadcast)
      },
      variables () {
        return {
          id: this.broadcastId
        }
      }
    }
  },
  computed: {
    loading () {
      return !this.broadcast && this.$apollo.queries.broadcast.loading
    }
  }
}
</script>
